%option nounput
%{
/*
pot est un programme servant a lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Generale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribue car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but specifique. Reportez-vous  la Licence Publique
Generale GNU pour plus de details.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include "kelsal_yy.h"
%}

quote           \"
string          [^#;\n"]*
separator	[\t ]+

%%

^{separator}*\n  { return EOL; }
{separator}*\n   { return EOL; }
^[#;].*$         { return NEUTRE; }

{quote}                       { return QUOTE; }
{separator}		      {    }

[Ss][Ii][Zz][Ee]              { yylval.string = yytext; return SIZE; }
[0-9]+                        { yylval.number = atoi(yytext); return NUMBER; }

{string}                      { yylval.string = yytext; return STRING;}

<<EOF>>			      { return 0; }
%%

int yywrap() { return 1; }
