%{
/*
pot est un programme servant a lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir recu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "kelsal.h"

  /* Les donnees renvoyes sont une salle et un nom d ordi */
  static char *salletp;
  static char *orditp;
  static int boolean;
  int yylex(void);
  int yyerror(char *);
%}

%union
{
  /* Type des donnees lues */
  char *string;
  int number;
}

/* On explique a quoi correpondent les types retournees par flex */
%token               SIZE QUOTE NEUTRE EOL
%token <string>	     STRING
%token <number>      NUMBER

%start               config_file
%%

/* Analyse d une ligne */
config_file: 	/* Vide */
                | lines
                ;

lines:		one_line lines
		| one_line
                ;

one_line:	QUOTE ordi QUOTE QUOTE salle QUOTE
                | QUOTE SIZE QUOTE QUOTE number QUOTE QUOTE salle QUOTE
                | NEUTRE
		| EOL
                ;

number:         NUMBER
                {
		  if ( strlen(orditp) == $1 )
		    {
		      boolean = 1;
		    }
                }
                ;

ordi:           STRING
                {
		if ( strncmp( orditp, yylval.string, strlen(yylval.string) ) == 0 )
		 {
		   boolean = 1;
		 }
                }
                ;


salle:          STRING
                {
		if ( boolean == 1 )
		  {
		    salletp = strdup(yylval.string);
		    return 0;
		  }
		}
                ;

%%

/* fonction execute lors d une erreur */
int yyerror (char *erreur)
{
  printf ("Erreur de lecture du fichier de config : %s\n"
	  "Verifie la syntaxe\n",
	  erreur);
  return -1;
}

char *chemin_potsal;

/* fonction en C appelle par le reste du programme */
char *kelsal(char *ordi)
{
  char *salle = NULL;
  FILE *rcfile;

  /* on prends le chemin de .pot.kelsal dans le repertoire de l utilisateur */
  if ( chemin_potsal == NULL )
    {
      if ( ( chemin_potsal = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
	{
	  fprintf( stderr , "Allocation de memoire impossible" );
	  return NULL;
	}
      strcpy ( chemin_potsal , getenv("HOME") );
      strcat ( chemin_potsal , POTSAL );
    }
  
  /* On essaye d ouvrir les reperrtoires par defauts. Si ca marche pas on renvoie tous les noms d ordis entre parantheses */
  if( (rcfile = fopen (chemin_potsal, "r")) == NULL )
    {
      if( (rcfile = fopen (POTSALDEFAULT, "r")) != NULL )
	{
	  /* lit le fichier de config */
	  orditp = strdup(ordi);
	  boolean=0;
	  salletp = NULL;
	  yyrestart(rcfile);
	  yyparse();
	  fclose(rcfile);
	}
    }
  else
    {
      /* lit le fichier de config */
      orditp = strdup(ordi);
      boolean=0;
      salletp = NULL;
      yyrestart(rcfile);
      yyparse();
      fclose(rcfile);
    }
  

  /* la salle n a pas ete trouve on la mets entre paranthese sinon on mets le nom de la salle */
  if (salletp == NULL)
    {	  
      if ( ( salle = (char *) malloc ( sizeof(strtok(ordi,".") + sizeof(char) * 2) ) ) == NULL )
	return NULL;
      strcpy(salle,"(");
      if (strlen(ordi) != 0)
	strcat(salle,strtok(ordi,"."));
      strcat(salle,")");
    }
  else
    salle = strdup(salletp);

  /* on desaloue la memoire */
  if (salletp != NULL)
    free(salletp);

  return salle;
}
