/*
pot est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#ifdef GTKUSE

#include <gtk/gtk.h>
#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <pwd.h>
#include "commun.h"
#include "potgtk.h"

/* Variable de selection de la c-liste*/
gint mySELECTED_ROW_pot_liste=0;
/* pointeur sur la premiere ocurrence de la liste_pot */
struct liste_pot *premier;

/* pour effacer une boite de dialogue particuliere */
void close_all(GtkWidget *w,GtkWidget *fenetre)
{
  gtk_widget_destroy(fenetre);
  suppr_all_liste_pot(premier);
  
  return;
}

void close_window(GtkWidget *w,GtkWidget *fenetre)
{
  gtk_widget_destroy(fenetre);
  
  return;
}


void enregistrer(GtkWidget *w,GtkWidget *window)
{
  char *chemin;
  
  /* recueil du chemin de pot.pot et de pot.pot.linux */
  if ( ( chemin = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
    {
      fprintf( stderr , "Allocation de memoire impossible" );
      return ;
    }
  strcpy ( chemin , getenv("HOME") );
  strcat ( chemin , "/.pot.pot" );

  fichier_liste_pot(chemin,premier);
  close_all(window,window);

  return ;
}

/* affiche la pot liste */
int affiche_liste_pot(struct liste_pot *premier, GtkWidget *liste)
{
    struct liste_pot *balade;
    int compteur=0;
    gchar *clist[2];
    struct passwd *ki;

    balade = premier;
    gtk_clist_clear(GTK_CLIST(liste));
    
    while(balade != NULL)
      {
	compteur++;
	/* c'est crade mais je test... */
	clist[0]=balade->login;
      
	if ( (ki=getpwnam(balade->login)) != NULL )
	  {
	    if ( (ki->pw_gecos[0] != ',') && (ki->pw_gecos[0] != '\0') )
	      {
		clist[1]=strtok(ki->pw_gecos,",");
	      }
	    else
	      {
		clist[1]="???";
	      }
	  }
	else
	  clist[1]="N'existe pas";
      
      
	gtk_clist_insert (GTK_CLIST(liste),0,clist);
	balade = balade->next;
      }

    /* ****************** */
  return compteur;

}

/* Pour sauver la selection dans la pot_liste */
void save_selected_pot_liste(GtkWidget *widget,
		   gint row,
		   gint column,
		   GdkEventButton *event,
		   gpointer data)
{
  mySELECTED_ROW_pot_liste=row;
}

void window_erreur(char *buffer)
{
  GtkWidget *window; /* la fenetre principale*/
  GtkWidget *Bouton; /* boutton Ok */
  GtkWidget *separateur;
  GtkWidget *main_vbox;
  GtkWidget *label;
  GtkWidget *hbox;

  /* Creation de la window secondaire */
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW (window), "Erreur");
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",(GtkSignalFunc)(gtk_widget_destroy), NULL);
  gtk_container_border_width (GTK_CONTAINER (window), 10);
  gtk_widget_show (window);
  /************************/

  /* create the main box */
  main_vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_widget_show (main_vbox);
  /***********************/

  /* creation des labels en hauts de la fenetre secondaire */
  label = gtk_label_new (buffer);
  gtk_box_pack_start (GTK_BOX (main_vbox), label,FALSE,TRUE,0);
  gtk_widget_show (label);
  /***********************/

  /* Creation du separateur entre le texte et les boutons */
  separateur=gtk_hseparator_new();
  gtk_box_pack_start (GTK_BOX (main_vbox), separateur,FALSE,TRUE,0);
  gtk_widget_show (separateur);
  /**********************/

  /* create the hbox for the buttons */
  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start(GTK_BOX(main_vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show (hbox);
  /***********************/

  /* boutton OK */
  Bouton=gtk_button_new_with_label ("OK");
  gtk_box_pack_start (GTK_BOX (hbox), Bouton,TRUE,FALSE,0);
  gtk_signal_connect (GTK_OBJECT (Bouton), "clicked",(GtkSignalFunc)(close_window),window );
  gtk_widget_show (Bouton);
  /*************************/

  return;
}


/* Pour effacer une fenetre particuliere */
void close_pot_liste(GtkWidget *w,GtkWidget *fenetre)
{
  GtkWidget *window; /* la fenetre principale*/
  GtkWidget *Bouton[2]; /*dans l'ordre Ok, annuler */
  GtkWidget *main_vbox,*hbox;
  GtkWidget *label;
  GtkWidget *separateur;
  int i;

  gtk_widget_destroy(fenetre);

  /* Creation de la window secondaire */
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize( GTK_WIDGET (window), 206, 80);
  gtk_window_set_title(GTK_WINDOW (window), "Confirmation");
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",(GtkSignalFunc)(gtk_widget_destroy), NULL);
  gtk_container_border_width (GTK_CONTAINER (window), 10);
  gtk_widget_show (window);
  /************************/

  /* create the main box */
  main_vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_widget_show (main_vbox);
  /***********************/

  /* creation des labels en hauts de la fenetre secondaire */
  label = gtk_label_new ("Voulez vous enregistrer ?");
  gtk_box_pack_start (GTK_BOX (main_vbox), label,FALSE,TRUE,0);
  gtk_widget_show (label);
  /***********************/

  /* Creation du separateur entre le texte et les boutons */
  separateur=gtk_hseparator_new();
  gtk_box_pack_start (GTK_BOX (main_vbox), separateur,FALSE,TRUE,0);
  gtk_widget_show (separateur);
  /**********************/

  /* create the hbox */
  hbox = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start(GTK_BOX(main_vbox), hbox, FALSE, TRUE, 0);
  gtk_widget_show (hbox);
  /***********************/

  /* boutton OK */
  Bouton[0]=gtk_button_new_with_label ("OK");
  gtk_signal_connect (GTK_OBJECT (Bouton[0]), "clicked",(GtkSignalFunc)enregistrer,GTK_OBJECT (window) );
  /*************************/

  /* boutton pour Annuler */
  Bouton[1]=gtk_button_new_with_label ("Annuler");
  gtk_signal_connect (GTK_OBJECT (Bouton[1]), "clicked",(GtkSignalFunc)(close_all), GTK_OBJECT (window));
  /************************/
  
  for(i=0;i<2;i++)
    {
      gtk_box_pack_start (GTK_BOX (hbox), Bouton[i],FALSE,TRUE,5);
      gtk_widget_show(Bouton[i]);
    }

  return;
}

void ajouter(GtkWidget *entry,GtkWidget *liste)
{
  if (verif_login(gtk_entry_get_text(GTK_ENTRY(entry)),2,NULL,premier) == 0)
    {
      premier=ajout_liste_pot( gtk_entry_get_text(GTK_ENTRY(entry)) , premier );
      gtk_editable_delete_text( GTK_EDITABLE(entry) , 0 , -1 );
      affiche_liste_pot(premier, liste  );
    }
  else
    {
      window_erreur("Ce login n'existe pas ou est deja enregistre");
      gtk_editable_delete_text( GTK_EDITABLE(entry) , 0 , -1 );
    }
  
  return;
  
}

void effacer(GtkWidget *entry, gpointer data)
{
  gchar *login[9];

  gtk_clist_get_text( GTK_CLIST(data),mySELECTED_ROW_pot_liste,0,(gchar **)login);
  premier = del_liste_pot(login[0], premier);
  affiche_liste_pot(premier,  data );
  
  return;  
}


/* modifier ses logins */
void gestion(void)
{
  GtkWidget *window; /* la fenetre principale*/
  GtkWidget *Bouton[3]; /*dans l'ordre ajouter, effacer quitter */
  GtkWidget *main_vbox, *hbox[2];
  GtkWidget *liste; /*la liste qui contient la "PoT-Liste"*/
  GtkWidget *label;
  GtkWidget *entry;
  gchar *titre[2]={"Login","Nom"};
  
  char *chemin;


  /* recueil du chemin de pot.pot et de pot.pot.linux */
  if ( ( chemin = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
    {
      fprintf( stderr , "Allocation de memoire impossible" );
      return;
    }
  strcpy ( chemin , getenv("HOME") );
  strcat ( chemin , "/.pot.pot" );
  /***********************/

  /* Creation de la window secondaire */
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize( GTK_WIDGET (window), 350, 400);
  gtk_window_set_title(GTK_WINDOW (window), "Gestion des \"PoT\"");
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",(GtkSignalFunc)(gtk_widget_destroy), NULL);
  /************************/

  
  /* create the main box */
  main_vbox = gtk_vbox_new (FALSE, 2);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_container_border_width (GTK_CONTAINER (main_vbox), 10);
  gtk_widget_show (main_vbox);
  /***********************/

  /* cration des labels en hauts de la fenetre secondaire */
  label = gtk_label_new ("PoT - GTK @2001");
  gtk_box_pack_start (GTK_BOX (main_vbox), label,FALSE,TRUE,0);
  gtk_widget_show (label);


  /* Je vais afficher le tout seulement apres avoir lu le fichier
     car il me faut le nombre de personne dans le fichier .pot.pot */
  /**clist**/
  liste=gtk_clist_new_with_titles(2,titre);
  gtk_clist_set_column_width (GTK_CLIST(liste), 0, 80);
 

  gtk_signal_connect(GTK_OBJECT(liste),
		     "select_row",
		     GTK_SIGNAL_FUNC(save_selected_pot_liste),
		     NULL);
  /************/

  /* Lecture du fichier et chargement dans une liste chainee */
  premier = charge_liste_pot(chemin);
  affiche_liste_pot(premier,liste);
  

  /* On peut maintenant cree le label contenant les informations sur le fichier .pot.pot */
  /* A Faire */

  /* Affichage de tous les elements crees depuis le dernier label */
  gtk_box_pack_start(GTK_BOX(main_vbox), liste, TRUE, TRUE, 0);
  gtk_widget_show (liste);
  /*********************/

  /* Les trois bouttons + les 2 boites */
  /* La premiere boite pour le boutton ajouter, le label login et la boite de texte */
  hbox[0] = gtk_hbox_new (FALSE, 2);
  gtk_box_pack_start (GTK_BOX (main_vbox),hbox[0],FALSE,FALSE, 0);
  gtk_widget_show (hbox[0]);

  /* La deuxieme boite pour le boutton effacer et le boutton quitter */
  hbox[1] = gtk_hbox_new (TRUE, 15);
  gtk_box_pack_start (GTK_BOX (main_vbox),hbox[1],FALSE,FALSE, 0);
  gtk_widget_show (hbox[1]);

  /* label login */
  label = gtk_label_new ("Login a ajouter : ");
  gtk_box_pack_start (GTK_BOX (hbox[0]), label,TRUE,FALSE,0);
  gtk_widget_show (label);

  /* Zone pour taper un login */
  entry = gtk_entry_new();
  gtk_entry_select_region (GTK_ENTRY (entry),0, 10);
  gtk_box_pack_start (GTK_BOX (hbox[0]), entry, TRUE, FALSE, 0);
  gtk_signal_connect( GTK_OBJECT(entry) , "activate" , (GtkSignalFunc)ajouter , liste );
  gtk_widget_show (entry);

  /* boutton pour ajouter */
  /*Bouton[0]=gtk_button_new_with_label ("Ajouter");
  gtk_box_pack_start (GTK_BOX (hbox[0]), Bouton[0],TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (Bouton[0]), "clicked",(GtkSignalFunc)ajouter, liste );
  gtk_widget_show (Bouton[0]);*/

  /* boutton pour effacer */
  Bouton[1]=gtk_button_new_with_label ("effacer");
  gtk_box_pack_start (GTK_BOX (hbox[1]), Bouton[1],TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (Bouton[1]), "clicked",(GtkSignalFunc)effacer, liste);
  gtk_widget_show (Bouton[1]);

  /* boutton pour quitter */
  Bouton[2]=gtk_button_new_with_label ("Close");
  gtk_box_pack_start (GTK_BOX (hbox[1]), Bouton[2],TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (Bouton[2]), "clicked",(GtkSignalFunc)(close_pot_liste), GTK_OBJECT (window));
  gtk_widget_show (Bouton[2]);
  /* **************************** */

  /* On montre tout */
  gtk_widget_show_all( window );
}

#endif
