/*
est pot un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "console.h"
#include "commun.h"

#ifdef GTKUSE
#include "potgtk.h"
#endif

/* fonction principal */
int main(int argc , char *argv[] /*, char *envp[]*/)
{
  /* initialisation des variables */
  int c , j, couleur = 1;
  char *chemin;
  FILE *pot;
  int erreur_pot = 0;


  /* recueil du chemin de pot.pot et de pot.pot.linux */
  if ( ( chemin = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
    {
      fprintf( stderr , "Allocation de memoire impossible" );
      return -1;
    }
  strcpy ( chemin , getenv("HOME") );
  strcat ( chemin , "/.pot.pot" );

  if ((pot = fopen(chemin, "r")) == NULL)
    {
      fprintf(stderr,"~/.pot.pot n'existe pas.\n"
	      "Pour plus d'informations tapez : pot -h\n");
	 erreur_pot = 1;
    }

  /* Les arguments */
  while ( ( c = getopt(argc,argv,"hlgtcr:") ) != -1 ) 
    switch ( c )
      {
	/* aide */
      case 'h' :
	printf("Pot %s par Fabien Carrion et Guillaume Pinot\n"
	       "G.U.I. par Tahorg\n"
	       "Participation de Bertrand Bonnafous\n\n"
	       "utilisation : %s [-c] [login1 [login2...] | -r login | -l | -h | -t | -g] ;\n"
	       "\tlogin1 login2\trajoute des logins dans votre liste de \"pot\" ;\n"
	       "\t-r\t\tenlve un login de votre liste de \"pot\" ;\n"
	       "\t-l\t\taffiche votre liste de \"pot\" ;\n"
#ifdef GTKUSE
	       "\t-g\t\tlance potgtk, la version Graphique ;\n"
#endif
	       "\t-c\t\tlance pot sans la couleur ;\n"
	       "\t-h\t\taffiche ce message d'aide.\n"
	       "Pour pouvoir personnalis son pot, il faut lire le fichier de configuration par dfaut\n"
	       "\n\thttp://wwwetu.utc.fr/~pinotgui/\n\n",VERSION,argv[0]);
	return 0;

	/* lance la version sans couleur */
      case 'c' :
	couleur = 0;
	break;

#ifdef GTKUSE
	/* Lance potgtk (en graphique) */
      case 'g' :
	   if (!erreur_pot)
		return potgtk(chemin , argc , argv);
#endif
	
	/* visualisation des logins enregistrs pour localhost */
      case 'l' :
	   if (!erreur_pot)
		view(chemin);
	   return 0;
	
	/* visualisation des logins enregistrs pour linux */
      case 't' :
	strcat(chemin,".linux");
	view(chemin);
	return 0;
	
	/* suppression d'un login pour localhost */
      case 'r' :
	   if(!erreur_pot)
		suppr(chemin,optarg);
	   return 0;
	
	/* arguments invalide */
      default  :
	printf("Tapez %s -h\n",argv[0]);
	return 0;
	
      }

  /* ajout le login dans le fichier ~/.pot.pot */
  if ( argc >= 2 )
    {
      pot = fopen(chemin, "a");
      erreur(pot);
      if (!strcmp(argv[1],"-c"))
	j = 1;
      else
	j = 0;
      for(; argv[++j] != 0 ;)
	{
	  if (verif_login(argv[j],1,chemin,NULL) == 0)
	    {
	      fprintf( pot , "%s\n" , argv[j] );
	      printf("%s a ete ajoute.\n",argv[j]);
	    }
	  else
	    printf("%s est un login inexistant ou deja present dans votre liste.\n",argv[j]);
	}
	 fclose(pot);
    }

  /* execution en mode console du programme */
  if(!erreur_pot)
    console ( chemin , couleur);

  return 0;
}
